$ !
$ ! Command procedure to Compile and Build the IdxTeX and GloTeX programs.
$ !
$ ! Build IdxTeX
$ !
$ CC /LIST IDXTEX.C
$ LIBRARY/REPLACE IDXTEX IDXTEX
$ CC /LIST IDXPARSE.C
$ LIBRARY/REPLACE IDXTEX IDXPARSE
$ CC /LIST IDXBUILD.C
$ LIBRARY/REPLACE IDXTEX IDXBUILD
$ CC /LIST IDXGEN.C
$ LIBRARY/REPLACE IDXTEX IDXGEN
$ CC /LIST IDXSPELL.C
$ LIBRARY/REPLACE IDXTEX IDXSPELL
$ SET COMMAND /OBJECT=IDXTABLE /LIST IDXTABLE.CLD
$ LIBRARY/REPLACE IDXTEX IDXTABLE
$ CC /LIST IDXCMD.C
$ LIBRARY/REPLACE IDXTEX IDXCMD
$ LINK/MAP/EXEC=IDXTEX	    IDXTEX/INCLUDE=(IDXTEX)/LIBRARY,  SYS$INPUT
SYS$LIBRARY:VAXCRTL/SHARE
$ !
$ ! Build Help Module for IdxTeX
$ !
$ RUNOFF /OUTPUT=IDXTEX IDXTEX.RNH
$ !
$ ! Build User's Guide for IdxTeX
$ !
$ idxtex := $sys$disk:[]idxtex
$ rename IdxTeX.lis	    IdxTeX.xxx
$ latex  IdxTeX
$ idxtex IdxTeX
$ latex  IdxTeX
$ latex  IdxTeX
$ qdrive IdxTeX
$ delete IdxTeX.lis;*
$ rename IdxTeX.xxx	    IdxTeX.lis
$ !
$ ! Compile and Build GloTeX
$ !
$ CC /LIST GLOTEX.C
$ LIBRARY/REPLACE GLOTEX GLOTEX
$ CC /LIST GLOBLDFIL.C
$ LIBRARY/REPLACE GLOTEX GLOBLDFIL
$ CC /LIST GLOBLDLAB.C
$ LIBRARY/REPLACE GLOTEX GLOBLDLAB
$ CC /LIST GLOCMD.C
$ LIBRARY/REPLACE GLOTEX GLOCMD
$ CC /LIST GLOMISS.C
$ LIBRARY/REPLACE GLOTEX GLOMISS
$ CC /LIST GLOSCAN.C
$ LIBRARY/REPLACE GLOTEX GLOSCAN
$ SET COMMAND /OBJECT=GLOTBL /LIST GLOTBL.CLD
$ LIBRARY/REPLACE GLOTEX GLOTBL
$ LIBRARY/REPLACE GLOTEX IDXSPELL
$ LINK/MAP/exec=GloTeX	    GloTeX/include=(GloTeX)/library, SYS$INPUT
SYS$LIBRARY:VAXCRTL/SHARE
$ !
$ ! Build Help Module for GloTeX
$ !
$ RUNOFF /OUTPUT=GLOTEX GLOTEX.RNH
$ !
$ ! Build User's Guide for GloTeX
$ !
$ glotex := $sys$disk:[]glotex
$ rename GloTeX.lis	    GloTeX.xxx
$ latex  GloTeX
$ idxtex GloTeX
$ glotex GloTeX	    /GLOSSARY=GloTeX
$ latex  GloTeX
$ latex  GloTeX
$ qdrive GloTeX
$ delete GloTeX.lis;*
$ rename GloTeX.xxx	    GloTeX.lis
